<template>
  <div
    :class="{
      'w-full': wFull
    }"
  >
    <Select
      v-model="value"
      :options="options"
      v-bind="$attrs"
      :invalid="invalid"
      :class="{
        'w-full': wFull
      }"
    />
    <small class="color-danger">{{ errorMessage || null }}</small>
  </div>
</template>

<script setup lang="ts">
import { useField } from 'vee-validate'
const attrs = useAttrs() as any

const props = defineProps({
  modelValue: {
    type: [String, Number],
    required: false,
    default: ''
  },
  options: {
    type: Array,
    required: true
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  },
  wFull: {
    type: Boolean,
    required: false
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
}) as any
</script>

<style lang="scss" scoped></style>
